//*****************************************************************************************************
//  1. t@C
//		MenuButton.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		상j[̃{^Rg[NX
//----------------------------------------------------------------------------------------------------
//  3. l
//*****************************************************************************************************

#include "stdafx.h"
#include "Schematic.h"
#include "MenuButton.h"


// CMenuButton

IMPLEMENT_DYNAMIC(CMenuButton, CButton)

BEGIN_MESSAGE_MAP(CMenuButton, CButton)
	ON_MESSAGE(BM_SETSTATE, OnSetState)
END_MESSAGE_MAP()


// CMenuButton bZ[W nh

//*****************************************************************************************************
//  1. ֐
//		CMenuButton::operator=
//----------------------------------------------------------------------------------------------------
//  2. @\
//		`FbNԐݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		BOOL	param		[I] Zbg`FbNԁiTRUE:`FbNԁCFALSEF`FbNԁj
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	ݒ肵`FbN
//*****************************************************************************************************
BOOL CMenuButton::operator=(BOOL param)
{
	if (GetCheck() != param)
		SetCheck(param);

	return param;
}

//*****************************************************************************************************
//  1. ֐
//		CMenuButton::operator BOOL
//----------------------------------------------------------------------------------------------------
//  2. @\
//		`FbNԎ擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	擾`FbN
//*****************************************************************************************************
CMenuButton::operator BOOL()
{
	return GetCheck();
}

//*****************************************************************************************************
//  1. ֐
//		CMenuButton::operator=
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^̃eLXgݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		pText		[I] ZbgeLXg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	ݒ肵eLXgւ̃|C^
//*****************************************************************************************************
LPCTSTR CMenuButton::operator=(LPCTSTR pText)
{
	SetWindowText(pText);
	return pText;
}

//*****************************************************************************************************
//  1. ֐
//		CMenuButton::SetEnable
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^̗L/Ԑݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		BOOL	bEnable		[I] L/ԁiTRUEFLCFALSEFj
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuButton::SetEnable(BOOL bEnable)
{
	if (!bEnable) {
		if ((GetButtonStyle() == BS_DEFPUSHBUTTON))
			SetButtonStyle(BS_PUSHBUTTON);
	}

	EnableWindow(bEnable);
}

//*****************************************************************************************************
//  1. ֐
//		CMenuButton::SetCheck
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^̃`FbNԐݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		BOOL	bCheck		[I] `FbNԁiTRUEF`FbNCFALSEF`FbNj
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuButton::SetCheck(BOOL bCheck)
{
	CButton::SetCheck(bCheck ? BST_CHECKED : BST_UNCHECKED);
}

//*****************************************************************************************************
//  1. ֐
//		CMenuButton::SetEnableAndCheck
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^̗L/Ԃƃ`FbNԐݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		BOOL	bEnable		[I] L/ԁiTRUEFLCFALSEFj
//		BOOL	bCheck		[I] `FbNԁiTRUEF`FbNCFALSEF`FbNj
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuButton::SetEnableAndCheck(BOOL bEnable, BOOL bCheck)
{
	SetEnable(bEnable);
	SetCheck(bCheck);
}

//*****************************************************************************************************
//  1. ֐
//		CMenuButton::OnSetState
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^Ԓʒm
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		WPARAM	wParam		[I] {^̏
//		LPARAM	lParam		[I] gp
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT		Default()
//*****************************************************************************************************
LRESULT CMenuButton::OnSetState(WPARAM wParam, LPARAM lParam)
{
	// {^ꂽƗɐeEBhEɃbZ[W𑗂
	if (GetKeyState(VK_SHIFT) >= 0)
		GetParent()->SendMessage(WM_COMMAND, (wParam ? (BN_PUSHED << 16) : (BN_UNPUSHED << 16)) | GetDlgCtrlID(), (LPARAM)m_hWnd);

	return Default();
}
